# from __future__ import absolute_import
# from ufl.algorithms import MultiFunction
# from dune.perftool.ufl.transformations import ufl_transformation

#
# class SplitArguments(MultiFunction):
#
#     call = MultiFunction.__call__
#
#     def __init__(self):
#         MultiFunction.__init__(self)
#
#     def __call__(self, o):
#         from dune.perftool.ufl.modified_terminals import ModifiedArgumentExtractor
#         self.ae = ModifiedArgumentExtractor()
#         from dune.perftool.ufl.rank import ufl_rank
#         self.rank = ufl_rank(o)
#         # call the actual recursive function
#         return self.call(o)
#
#     def expr(self, o):
#         return self.reuse_if_untouched(o, *tuple(self.call(op) for op in o.ufl_operands))
#
#     def product(self, o):
#         from dune.perftool.ufl.flatoperators import get_operands, construct_binary_operator
#         from itertools import product as iterproduct
#         from ufl.classes import Sum, Product
#
#         # Check whether this product is fine!
#         if len(self.ae(o)) == self.rank:
#             return self.reuse_if_untouched(o, *(self.call(op) for op in o.ufl_operands))
#
#         # It is not, lets switch sums and products!
#         # First we apply recursively to all
#         product_operands = [get_operands(self.call(op)) if isinstance(op, Sum) else (self.call(op),) for op in get_operands(o)]
#         # Multiply all terms by taking the cartesian product of terms
#         distributive = [f for f in iterproduct(*product_operands)]
#         # Prepare all sum terms by introducing products
#         sum_terms = [construct_binary_operator(s, Product) for s in distributive]
#         # Return the big sum.
#         return construct_binary_operator(sum_terms, Sum)
#
#
# @ufl_transformation(name="split")
# def split_arguments(expr):
#     return SplitArguments()(expr)
